close all;
clear all;

%Code Calculates the TV, Laplacian, and Frobenius Norm of Hessian
%objectives for an example image

%Import image
I = rgb2gray(im2double(imread('gordon.jpg')));
figure; imshow(I);

%Total Variation

%convolution kernels
fx = [0 0 0; 0 -1 1; 0 0 0];
fy = [0 0 0; 0 -1 0; 0 1 0]; 

%Calculate prior objective
I_TV = sqrt((ifft2(fft2(I).*psf2otf(fx,size(I)))).^2 + (ifft2(fft2(I).*psf2otf(fy,size(I)))).^2);
figure; imshow(I_TV);
resid_TV = sum(abs(I_TV(:)))


%Laplacian

%convolution kernel
f2 = [0 1 0; 1 -4 1; 0 1 0]; 

%Calculate prior objective
I_L = ((ifft2(fft2(I).*psf2otf(f2,size(I)))));
figure; imshow(I_L);
resid_L = sum(abs(I_L(:)))


%Frobenius norm of Hessian

%generate 2nd order kernels
fxx = ifft2(fft2(fx).*fft2(fx));
fxy = ifft2(fft2(fx).*fft2(fy));
fyy = ifft2(fft2(fy).*fft2(fy));

Dxx = ifft2(fft2(I) .* psf2otf(fxx,size(I)));
Dxy = ifft2(fft2(I) .* psf2otf(fxy,size(I)));
Dyy = ifft2(fft2(I) .* psf2otf(fyy,size(I)));

%Calculate prior objective
I_F  = sqrt(Dxx.^2 + Dxy.^2 + Dxy.^2 + Dyy.^2);
figure; imshow(I_F);
resid_F = norm(I_F,'fro')

