function [lambda_opt] = lambdaopt(b,c,I)
%Optimizes tuning paramter for each prior
lambdas = [0.01 0.005 0.001 0.0005 0.0001 0.00005 0.00001];
for i = 1:length(lambdas)
    
    lambda = lambdas(i);
    %TV
    [x,time,performance,convergence] = deblur(b,c,I,'TV',lambda);
    psnr_tv(:,i) = performance(:,end);
    
    %Laplacian
    [x,time,performance,convergence] = deblur(b,c,I,'Lap1',lambda);
    psnr_l(:,i) = performance(:,end);
    
    %Frobenius of Hessian
    [x,time,performance,convergence] = deblur(b,c,I,'Fro',lambda);
    psnr_f(:,i) = performance(:,end);
    
end
%find best SSIM
[tv_opt tv_ind] = max(psnr_tv(2,:));
[l_opt l_ind] = max(psnr_l(2,:));
[f_opt f_ind] = max(psnr_f(2,:));

lambda_opt(1) = lambdas(tv_ind);
lambda_opt(2) = lambdas(l_ind);
lambda_opt(3) = lambdas(f_ind);
